% M-file 9.3
% calc_lpc.m

function [a,g]=calc_lpc(x,p)
% calculate LPC coeffs via autocorrelation method
% Similar to MATLAB function "lpc" 
% IMPORTANT: function "lpc" does not work correctly with MATLAB 6!
% x: input signal
% p: prediction order
% a: LPC coefficients
% g: gain factor
% (c) 2002 Florian Keiler

R=xcorr(x,p);       % autocorrelation sequence R(k) with k=-p,..,p
R(1:p)=[];          % delete entries for k=-p,..,-1
if norm(R)~=0
   a=levinson(R,p);    % Levinson-Durbin recursion
% a=[1, -a_1, -a_2,..., -a_p]
else
    a=[1, zeros(1,p)];
end    
R=R(:)'; a=a(:)';   % row vectors
g=sqrt(sum(a.*R));  % gain factor
