function y=synth_sine_fade(pitches,K,Fs)
% y=synth_sine_fade(pitches,K,Fs)
%
% generate synthetic phase-continous sine
% pitches: vector with pitches of blocks
% K: block length
% Fs: sampling freq
% 
% (c) 2002 Florian Keiler

blocks=length(pitches);
phi0=0; %starting phase
t=(1:K)/Fs; %time per block in seconds
%F=round(K/4); %fade length
F=K; %fade length
fin=ones(1,K);
fout=ones(1,K);
fin(1:F)=(0:F-1)./(F-1); % fade in from 0 to 1
fout(K-F+1:K)=fin(F:-1:1); % fade out from 1 to 0

y=zeros(blocks*K,1);

prev=0; % prev block synthesized?
next=1; % next block synthesized?
for b=1:blocks
  if b<blocks
    next=pitches(b+1);
  else
    next=0;
  end  
  
  if pitches(b)
   if prev==0
     phi0=0;
   end  
   arg=2*pi*pitches(b)*t +phi0;
   yblock=cos(arg);
%   yblock=sawtooth(arg);
   phi0=arg(K);  % starting phase for next block
  else
   yblock=zeros(1,K);
  end 
  
  if prev==0
   yblock=yblock.*fin;
  end 
  if next==0
   yblock=yblock.*fout;
  end 
  y((b-1)*K+(1:K))=yblock;
  prev=pitches(b);
end


